## libcerf 2.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14 FATAL_ERROR)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(PreventInSourceBuilds)

if(NOT DEFINED BUILD_SHARED_LIBS)
    option(BUILD_SHARED_LIBS "Build as shared library" ON)
endif()
if(NOT DEFINED LIB_MAN)
    option(LIB_MAN "Build libcerf man pages" ON)
endif()
if(NOT DEFINED LIB_RUN)
    option(LIB_RUN "Build executables for command-line computation" ON)
endif()
if(NOT DEFINED CERF_CPP)
    option(CERF_CPP "Build libcerf as native C++" OFF)
endif()

if(CERF_CPP)
    project(cerfcpp CXX)
    message("Build C++ library libcerfcpp")
    # add_compile_definitions(CERF_AS_CPP) # requires CMake 3.13, therefore more explicitly:
    if(MSVC)
        add_compile_options(/DCERF_AS_CPP)
    else()
        add_compile_options(-DCERF_AS_CPP)
    endif()
    set(CMAKE_CXX_STANDARD 11)
else()
    message("Build C library libcerf")
    project(cerf C)
    set(CMAKE_C_STANDARD 99)
endif()

set(CERF_SOVERSION                 2) # API version
set(CERF_VERSION ${CERF_SOVERSION}.4) # minor version

include(GNUInstallDirs)

SET(CERF_COMPILE_OPTIONS "" CACHE
    STRING "User-supplied compiler options, will be appended to hard-coded ones. Not for Windows.")

if(MSVC)
    if (NOT CERF_CPP)
        message(FATAL_ERROR "Under MSVC, only CERF_CPP=ON is supported")
    endif()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP") # parallel compilation
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS}")
    set(MS_NOWARN "/wd4018 /wd4068 /wd4101 /wd4244 /wd4267 /wd4305 /wd4715 /wd4996")
    set(MS_D "-D_CRT_SECURE_NO_WARNINGS -D_SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS} ${MS_NOWARN} ${MS_D}")
    set(CTEST_CONFIGURATION_TYPE "${JOB_BUILD_CONFIGURATION}")
    if(BUILD_SHARED_LIBS)
        set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    else()
        # required for post-build validation under vcpkg:
        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd") # multithreaded, debug
    endif()
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

elseif(CERF_COMPILE_OPTIONS)
    add_compile_options(${CERF_COMPILE_OPTIONS})

else()
    option(PEDANTIC "Compile with pedantic warnings" ON)
    option(WERROR "Treat warnings as errors" OFF)
    if(PEDANTIC)
        add_compile_options(-pedantic -Wall)
    endif()
    if(WERROR)
        add_compile_options(-Werror)
    endif()

    add_compile_options(-Wno-sign-compare -fno-omit-frame-pointer)
    if (CMAKE_BUILD_TYPE MATCHES Debug)
        add_compile_options(-g)
    else()
        add_compile_options(-O3)
    endif()
endif()

include(CTest)

configure_file("libcerf.pc.in" "libcerf.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libcerf.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")

add_subdirectory(lib)
add_subdirectory(test)
if(LIB_RUN)
    add_subdirectory(run)
endif()
if(LIB_MAN)
    add_subdirectory(man)
endif()

=== lib/CMakeLists.txt ===
set(lib cerf)
set(intf "c_interface")
if (${CERF_CPP})
    set(lib cerfcpp)
    set(intf "cxx_interface")
endif()
message(STATUS
    "libcerf/lib: build library ${lib}, CERF_CPP=${CERF_CPP}, shared=${BUILD_SHARED_LIBS}")

set(cerf_LIBRARY ${lib} PARENT_SCOPE)

set(src_files erfcx.c err_fcts.c im_w_of_x.c w_of_z.c width.c)
set(inc_files cerf.h)

if (${CERF_CPP})
    set_property(SOURCE ${src_files} PROPERTY LANGUAGE CXX)
endif()

add_library(${lib} ${src_files})

set_target_properties(
    ${lib} PROPERTIES
    OUTPUT_NAME ${lib}
    VERSION ${CERF_VERSION}
    SOVERSION ${CERF_SOVERSION})
if (${CERF_CPP})
    set_target_properties(${lib} PROPERTIES LINKER_LANGUAGE CXX)
endif()

if(NOT MSVC)
    target_link_libraries(${lib} m)
endif()

target_include_directories(${lib} INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

install(
    TARGETS ${lib}
    EXPORT ${intf}
    RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT Libraries)
install(
    FILES ${inc_files}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    COMPONENT Headers)

include(CMakePackageConfigHelpers)
set(CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/cerf")
configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/cerfConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/cerfConfig.cmake"
  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR})
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/cerfConfigVersion.cmake
  VERSION ${CERF_VERSION}
  COMPATIBILITY SameMajorVersion)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cerfConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/cerfConfigVersion.cmake
  DESTINATION ${CMAKECONFIG_INSTALL_DIR})
install(EXPORT ${intf}
  NAMESPACE "cerf::"
  FILE "cerfTargets.cmake"
  DESTINATION ${CMAKECONFIG_INSTALL_DIR})

set(CPACK_PACKAGE_VENDOR "Forschungszentrum Jülich GmbH")
set(CPACK_PACKAGE_VERSION ${CERF_VERSION})
set(CPACK_GENERATOR "ZIP")
include(CPack)

=== run/CMakeLists.txt ===
set(apps
    runvoigt
    runfwhm
    run_w_of_z
    tabulate
    bigloop
    )

foreach(app ${apps})
    if (${CERF_CPP})
        set_property(SOURCE ${app}.c PROPERTY LANGUAGE CXX)
    endif()
    add_executable(${app} ${app}.c)
    target_include_directories(${app} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../lib)
    if (${CERF_CPP})
        set_property(TARGET ${app} PROPERTY LINKER_LANGUAGE CXX)
    endif()
    target_link_libraries(${app} ${cerf_LIBRARY})
endforeach()

=== test/CMakeLists.txt ===
file(GLOB tests *test.c)

foreach(src ${tests})
    if (${CERF_CPP})
        set_property(SOURCE ${src} PROPERTY LANGUAGE CXX)
    endif()
    get_filename_component(test ${src} NAME_WE)
    add_executable(${test} ${src})
    target_include_directories(${test} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../lib)
    if (${CERF_CPP})
        set_property(TARGET ${test} PROPERTY LINKER_LANGUAGE CXX)
    endif()
    target_link_libraries(${test} ${cerf_LIBRARY})
    add_test(NAME ${test} COMMAND ${test})
endforeach()

## libcerf 1.3

=== debian/changelog ===
libcerf (1.3-2build1) eoan; urgency=medium

  * No-change rebuild to drop multiarch-support dependency.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 01 Sep 2019 03:40:26 +0000

libcerf (1.3-2) unstable; urgency=medium

  * debian/control
    - Add Breaks and Replaces manpages-dev (Closes: #768209, #764310)

 -- Eugen Wintersberger <eugen.wintersberger@gmail.com>  Sat, 15 Nov 2014 12:16:10 +0100

libcerf (1.3-1) unstable; urgency=low

  * Initial release (Closes: #714800)  

 -- Eugen Wintersberger <eugen.wintersberger@gmail.com>  Mon, 02 Jun 2014 20:59:02 +0200

=== debian/control ===
Source: libcerf
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org> 
Uploaders: Eugen Wintersberger <eugen.wintersberger@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               automake,
               dh-autoreconf
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/libcerf.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/libcerf.gi
Homepage: http://apps.jcns.fz-juelich.de/doku/sc/libcerf

Package: libcerf1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Complex error function library - binary files
 libcerf is a self-contained numeric library that provides an efficient and
 accurate implementation of the complex error functions, along with Dawson,
 Faddeeva, and Voigt functions.
 . 
 This package contains the runtime binary of the library.

Package: libcerf1-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libcerf1 (=${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Complex error function library - debugging symbols
 libcerf is a self-contained numeric library that provides an efficient and
 accurate implementation of the complex error functions, along with Dawson,
 Faddeeva, and Voigt functions.
 . 
 This package contains the debugging symbols for the library.

Package: libcerf-dev
Architecture: any
Section: libdevel
Depends: libcerf1 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Complex error function library - development files
 libcerf is a self-contained numeric library that provides an efficient and
 accurate implementation of the complex error functions, along with Dawson,
 Faddeeva, and Voigt functions.
 .
 This package contains the development files for libcerf. 

Package: libcerf-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Breaks: manpages-dev (<< 3.74)
Replaces: manpages-dev (<< 3.74)
Description: Complex error function library - development files
 libcerf is a self-contained numeric library that provides an efficient and
 accurate implementation of the complex error functions, along with Dawson,
 Faddeeva, and Voigt functions.
 .
 This package contains the man pages and html documentation for libcerf.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --with autoreconf --dbg-package=libcerf1-dbg

override_dh_auto_configure:
	dh_auto_configure -- --docdir=/usr/share/doc/libcerf-doc 

override_dh_clean:
	#this directory is not used for the build and thus not mentioned
	#in the copyright file
	rm -rf fortran
	dh_clean

## libcerf 2.3

=== debian/changelog ===
libcerf (2.3-2) unstable; urgency=medium

  * Bug fix: "base line violatin: builds with -march=native", thanks to
    Sebastian Ramacher (Closes: #1042434).
  * Bug fix: "package short description mentions &quot;development
    files&quot; instead of documentation", thanks to Beatrice Torracca
    (Closes: #867708).
  * Bug fix: "DebSci Additional info upstream homepage (also deprecated
    Debian CVS note)", thanks to Ben Tris (Closes: #958285). 

 -- Roland Mas <lolando@debian.org>  Fri, 28 Jul 2023 15:10:23 +0200

libcerf (2.3-1) unstable; urgency=medium

  * New upstream release.
  * Adding myself to uploaders. Thanks, Eugen!
  * Drop unneeded patch.
  * Patch a few installation paths.
  * Override Lintian false positive.

 -- Roland Mas <lolando@debian.org>  Wed, 26 Jul 2023 15:36:53 +0200

libcerf (1.13-1) UNRELEASED; urgency=medium

  * Fixed patchs for upstream version 1.5
  * Fixed standard in debian/control
  * New upstream version 1.13

 -- Eugen Wintersberger <eugen.wintersberger@gmail.com>  Wed, 13 Mar 2019 21:40:59 +0100

libcerf (1.5-1) unstable; urgency=medium

  * Imported Upstream version 1.5

 -- Eugen Wintersberger <eugen.wintersberger@gmail.com>  Mon, 17 Oct 2016 13:37:46 +0200

=== debian/watch ===
version=4
opts=\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.]*@ARCHIVE_EXT@)/@PACKAGE@-$1/ \
https://jugit.fz-juelich.de/mlz/libcerf/-/tags .*/v?@ANY_VERSION@/.*@ANY_VERSION@@ARCHIVE_EXT@

## libcerf 2.4

=== debian/changelog ===
libcerf (2.4-2build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:43:56 +0200

libcerf (2.4-2) unstable; urgency=medium

  * Bug fix: "please make the build reproducible", thanks to Chris Lamb
    (Closes: #1042954).
  * Update Lintian override following new upstream release.

 -- Roland Mas <lolando@debian.org>  Sat, 05 Aug 2023 21:04:52 +0200

libcerf (2.4-1) unstable; urgency=medium

  [ Roland Mas ]
  * Update debian/watch.

  [ Picca Frédéric-Emmanuel ]
  * New upstream version 2.4
  * d/p/002-Fix-arch-native-compilation.patch: Useless
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 03 Aug 2023 11:01:03 +0200

=== debian/control ===
Source: libcerf
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Eugen Wintersberger <eugen.wintersberger@gmail.com>,
 Roland Mas <lolando@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/libcerf
Vcs-Git: https://salsa.debian.org/science-team/libcerf.git
Homepage: https://jugit.fz-juelich.de/mlz/libcerf

Package: libcerf2
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Complex error function library - binary files
 libcerf is a self-contained numeric library that provides an efficient and
 accurate implementation of the complex error functions, along with Dawson,
 Faddeeva, and Voigt functions.
 .
 This package contains the runtime binary of the library.

Package: libcerf-dev
Architecture: any
Section: libdevel
Depends: libcerf2 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Complex error function library - development files
 libcerf is a self-contained numeric library that provides an efficient and
 accurate implementation of the complex error functions, along with Dawson,
 Faddeeva, and Voigt functions.
 .
 This package contains the development files for libcerf.

Package: libcerf-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Breaks: manpages-dev (<< 3.74)
Replaces: manpages-dev (<< 3.74)
Description: Complex error function library - documentation
 libcerf is a self-contained numeric library that provides an efficient and
 accurate implementation of the complex error functions, along with Dawson,
 Faddeeva, and Voigt functions.
 .
 This package contains the man pages and html documentation for libcerf.

## libcerf 3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.14 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.20 FATAL_ERROR)
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 include(PreventInSourceBuilds)
@@ -12,38 +12,44 @@
 if(NOT DEFINED LIB_RUN)
     option(LIB_RUN "Build executables for command-line computation" ON)
 endif()
+if(NOT DEFINED CERF_C)
+    option(CERF_C "Build C library libcerf" ON)
+endif()
 if(NOT DEFINED CERF_CPP)
-    option(CERF_CPP "Build libcerf as native C++" OFF)
+    option(CERF_CPP "Build C++ libcerfcpp" ON)
+endif()
+if(NOT DEFINED CERF_IEEE754)
+    option(CERF_IEEE754 "Assume IEEE754 floating-point layout" ON)
+    # Use our frexp2 instead of frexp from libc.
+    # It is unclear though whether the remainder of the code will work on non-IEEE754 machines.
 endif()
 
-if(CERF_CPP)
-    project(cerfcpp CXX)
-    message("Build C++ library libcerfcpp")
-    # add_compile_definitions(CERF_AS_CPP) # requires CMake 3.13, therefore more explicitly:
-    if(MSVC)
-        add_compile_options(/DCERF_AS_CPP)
-    else()
-        add_compile_options(-DCERF_AS_CPP)
+project(cerf LANGUAGES NONE)
+if (CERF_C)
+    if(WIN32)
+        message(FATAL_ERROR "Compilation as C not supported by MSVC, use -DCERF_C=OFF")
     endif()
-    set(CMAKE_CXX_STANDARD 11)
-else()
-    message("Build C library libcerf")
-    project(cerf C)
-    set(CMAKE_C_STANDARD 99)
+    enable_language(C)
+    set(CMAKE_C_STANDARD 11)
+endif()
+if (CERF_CPP)
+    enable_language(CXX)
+    set(CMAKE_CXX_STANDARD 17)
 endif()
 
-set(CERF_SOVERSION                 2) # API version
-set(CERF_VERSION ${CERF_SOVERSION}.4) # minor version
+set(CERF_SOVERSION                 3) # API version
+set(CERF_VERSION ${CERF_SOVERSION}.1) # minor version
 
 include(GNUInstallDirs)
 
 SET(CERF_COMPILE_OPTIONS "" CACHE
     STRING "User-supplied compiler options, will be appended to hard-coded ones. Not for Windows.")
 
+if (CERF_IEEE754)
+    add_compile_definitions(CERF_IEEE754)
+endif()
+
 if(MSVC)
-    if (NOT CERF_CPP)
-        message(FATAL_ERROR "Under MSVC, only CERF_CPP=ON is supported")
-    endif()
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP") # parallel compilation
     set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS}")
     set(MS_NOWARN "/wd4018 /wd4068 /wd4101 /wd4244 /wd4267 /wd4305 /wd4715 /wd4996")
@@ -82,15 +88,22 @@
 
 include(CTest)
 
-configure_file("libcerf.pc.in" "libcerf.pc" @ONLY)
-install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libcerf.pc"
-    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")
+set(CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
 
-add_subdirectory(lib)
-add_subdirectory(test)
+if(CERF_CPP)
+    add_subdirectory(libcpp)
+    add_subdirectory(testcpp)
+endif()
+if(CERF_C)
+    add_subdirectory(libc)
+    add_subdirectory(testc)
+endif()
+include("cmake/installCerf.cmake")
+
 if(LIB_RUN)
     add_subdirectory(run)
 endif()
+
 if(LIB_MAN)
     add_subdirectory(man)
 endif()

=== libc/CMakeLists.txt ===
set(lib cerf)
set(CERF_TARGET_CPP OFF)
set(cerf_LIBRARY ${lib} PARENT_SCOPE)

include("../cmake/buildLib.cmake")

=== libcpp/CMakeLists.txt ===
set(lib cerfcpp)
set(CERF_TARGET_CPP ON)
set(cerfcpp_LIBRARY ${lib} PARENT_SCOPE)

include("../cmake/buildLib.cmake")

=== man/CMakeLists.txt ===
function(one_page pname section srcname)
    add_custom_command(
        OUTPUT "${pname}.${section}"
        COMMAND pod2man -s ${section} -c "libcerf manual"
            "${CMAKE_CURRENT_SOURCE_DIR}/${srcname}.pod"
            "${CMAKE_CURRENT_BINARY_DIR}/${pname}.${section}"
        DEPENDS ${srcname}.pod
        )
    add_custom_command(
        OUTPUT ${pname}.html
        COMMAND pod2html --title="libcerf manual" --noindex
            ${CMAKE_CURRENT_SOURCE_DIR}/${srcname}.pod
            > ${CMAKE_CURRENT_BINARY_DIR}/${pname}.html
        DEPENDS ${srcname}.pod
        )
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${pname}.${section}
        DESTINATION "${CMAKE_INSTALL_MANDIR}/man${section}"
        )
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${pname}.html
        DESTINATION "${CMAKE_INSTALL_DOCDIR}/html"
        )
    set(TARGETS_MAN "${TARGETS_MAN};${pname}.${section}" PARENT_SCOPE)
    set(TARGETS_HTM "${TARGETS_HTM};${pname}.html"       PARENT_SCOPE)
endfunction()

set(TARGETS_MAN "")
set(TARGETS_HTM "")

one_page(cerf       3 cerf)
one_page(cerfc      3 cerf)
one_page(dawson     3 dawson)
one_page(cdawson    3 dawson)
one_page(erfcx      3 erfcx)
one_page(cerfcx     3 erfcx)
one_page(erfi       3 erfi)
one_page(cerfi      3 erfi)
one_page(voigt      3 voigt)
one_page(voigt_hwhm 3 voigt_hwhm)
one_page(w_of_z     3 w_of_z)
one_page(im_w_of_z  3 w_of_z)

# message(STATUS "targets man: ${TARGETS_MAN}")
# message(STATUS "targets htm: ${TARGETS_HTM}")
add_custom_target(man  ALL DEPENDS ${TARGETS_MAN})
add_custom_target(html ALL DEPENDS ${TARGETS_HTM})

=== run/CMakeLists.txt ===
set(apps
    run_erfcx
    run_fwhm
    run_imwofx
    run_voigt
    run_wofz
    tabulate
    bigloop
    )

if (CERF_C)
    foreach(app ${apps})
        add_executable(${app} ${app}.c)
        target_include_directories(${app} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../lib)
        target_link_libraries(${app} ${cerf_LIBRARY})
    endforeach()

else()
    foreach(app ${apps})
        set_property(SOURCE ${app}.c PROPERTY LANGUAGE CXX)
        add_executable(${app} ${app}.c)
        target_include_directories(${app} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/../lib)
        set_property(TARGET ${app} PROPERTY LINKER_LANGUAGE CXX)
        target_link_libraries(${app} ${cerfcpp_LIBRARY})
    endforeach()

endif()

=== testc/CMakeLists.txt ===
file(GLOB tests ../test/*test.c)

foreach(src ${tests})
    get_filename_component(test ${src} NAME_WE)
    add_executable(${test}_c ${src})
    target_include_directories(${test}_c PRIVATE ${CMAKE_SOURCE_DIR}/lib)
    target_link_libraries(${test}_c ${cerf_LIBRARY})
    add_test(NAME ${test}_c COMMAND ${test}_c)
endforeach()

=== testcpp/CMakeLists.txt ===
file(GLOB tests ../test/*test.c)

foreach(src ${tests})
    set_property(SOURCE ${src} PROPERTY LANGUAGE CXX)
    get_filename_component(test ${src} NAME_WE)
    add_executable(${test}_cpp ${src})
    target_include_directories(${test}_cpp PRIVATE ${CMAKE_SOURCE_DIR}/lib)
    set_property(TARGET ${test}_cpp PROPERTY LINKER_LANGUAGE CXX)
    target_link_libraries(${test}_cpp ${cerfcpp_LIBRARY})
    add_test(NAME ${test}_cpp COMMAND ${test}_cpp)
endforeach()

=== debian/changelog ===
libcerf (3.1-3) unstable; urgency=medium

  * Backport more proper fix to s390x segfault.

 -- Roland Mas <lolando@debian.org>  Mon, 18 Aug 2025 18:12:37 +0200

libcerf (3.1-2) unstable; urgency=medium

  * Build with -DCERF_IEEE754=OFF to fix segfault on s390x.

 -- Roland Mas <lolando@debian.org>  Sat, 16 Aug 2025 21:38:09 +0200

libcerf (3.1-1) unstable; urgency=medium

  * New upstream release.
  * Rename libcerf2 to libcerf3.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Aug 2025 01:55:08 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: libcerf
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders:
  Eugen Wintersberger <eugen.wintersberger@gmail.com>,
  Roland Mas <lolando@debian.org>
@@ -13,7 +12,7 @@
 Vcs-Git: https://salsa.debian.org/science-team/libcerf.git
 Homepage: https://jugit.fz-juelich.de/mlz/libcerf
 
-Package: libcerf2
+Package: libcerf3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends},
@@ -29,7 +28,7 @@
 Package: libcerf-dev
 Architecture: any
 Section: libdevel
-Depends: libcerf2 (= ${binary:Version}),
+Depends: libcerf3 (= ${binary:Version}),
          ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Complex error function library - development files

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

export CMAKE_OPTIONS := \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DWITH_SHARED_LIB=1 \
  -DWITH_STATIC_LIB=0 \
  -DWITH_PKGCONFIG_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
  -DCMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH) \
  -DCMAKE_BUILD_TYPE=Release

CONFIG_SWITCHES=-DCMAKE_DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS) $(CONFIG_SWITCHES) -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
opts=\
dversionmangle=auto,\
filenamemangle=s/.*?v(\d[\d\.]*@ARCHIVE_EXT@)/@PACKAGE@-$1/ \
https://jugit.fz-juelich.de/mlz/libcerf/-/tags .*/v?@ANY_VERSION@/.*@ARCHIVE_EXT@
